#include "IR.hpp"
#include "AST.hpp"
#include "EsterelPrinter.hpp"
#include <iostream>
#include <stdlib.h>

int main()
{
  try {

    IR::XMListream r(std::cin);
    IR::Node *n;
    r >> n;

    AST::ASTNode *an = dynamic_cast<AST::ASTNode*>(n);
    if (!an) throw IR::Error("Root node is not an AST node");

    AST::EsterelPrinter p(std::cout);
    an->welcome(p);

  } catch (IR::Error &e) {
    std::cerr << e.s << std::endl;
    exit(-1);
  }

  return 0;

}
